---
title: RTCPeerConnection.addTransceiver()
slug: Web/API/RTCPeerConnection/addTransceiver
tags:
  - API
  - Audio
  - Media
  - RTCPeerConnection
  - RTCRtpTransceiver
  - RTP
  - Reference
  - Transceivers
  - Video
  - addTransceiver
---
<div>{{APIRef("WebRTC")}}</div>

<p><span class="seoSummary">The {{domxref("RTCPeerConnection")}} method <code><strong>addTransceiver()</strong></code> creates a new {{domxref("RTCRtpTransceiver")}} and adds it to the set of transceivers associated with the <code>RTCPeerConnection</code>.</span> Each transceiver represents a bidirectional stream, with both an {{domxref("RTCRtpSender")}} and an {{domxref("RTCRtpReceiver")}} associated with it.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox"><em>rtpTransceiver</em> = <em>RTCPeerConnection</em>.addTransceiver(<em>trackOrKind</em>, <em>init</em>);</pre>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt><code>trackOrKind</code></dt>
 <dd>A {{domxref("MediaStreamTrack")}} to associate with the transceiver, or a {{domxref("DOMString")}} which is used as the {{domxref("MediaStreamTrack.kind", "kind")}} of the receiver's {{domxref("RTCRtpReceiver.track", "track")}}, and by extension of the {{domxref("RTCRtpReceiver")}} itself.</dd>
 <dt><code>init</code> {{optional_inline}}</dt>
 <dd>An object that conforms to the {{domxref("RTCRtpTransceiverInit")}} dictionary which provides any options that you may wish to specify when creating the new transceiver. Possible values are: {{page("/en-US/docs/Web/API/RTCRtpTransceiverInit", "Properties")}}</dd>
</dl>

<h3 id="Exceptions">Exceptions</h3>

<dl>
 <dt><code>TypeError</code></dt>
 <dd>A string was specified as <code>trackOrKind</code> which is not valid. The string must be either <code>"audio"</code> or <code>"video"</code>.</dd>
</dl>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName("WebRTC 1.0", "#dom-rtcpeerconnection-addtransceiver", "RTCPeerConnection.addTransceiver()")}}</td>
   <td>{{Spec2("WebRTC 1.0")}}</td>
   <td> </td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div>

<p>{{Compat("api.RTCPeerConnection.addTransceiver")}}</p>
</div>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/API/WebRTC_API">WebRTC API</a></li>
 <li><a href="/en-US/docs/Web/API/WebRTC_API/Intro_to_RTP">Introduction to the Real-time Transport Protocol (RTP)</a></li>
 <li>{{domxref("RTCPeerConnection.addTrack()")}} also creates transceivers</li>
 <li>{{domxref("RTCRtpReceiver")}} and {{domxref("RTCRtpSender")}}</li>
</ul>
